<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\MsgCalculo;
use Teknisa\Model\Gestaopessoas\Repositories\FpaEventom;


class FpaeventohEntity extends TkEntity
{   
    const IDDTOCORRENCIA_COMPETENCIA = 'COMPETENCIA';
    const IDDTOCORRENCIA_PAGAMENTO = 'PAGAMENTO';
    const IDUNIDREFEREVEN_PERCENTUAL = 'PERCENTUAL';
    const IDUNIDREFEREVEN_HORA = 'HORA';
    const IDUNIDREFEREVEN_COTA = 'COTA';
    const IDUNIDREFEREVEN_DIA = 'DIA';
    const IDUNIDREFEREVEN_12_AVOS = '12_AVOS';
    const IDUNIDREFEREVEN_HORA_MINUTO = 'HORA_MINUTO';
    const IDEVENTODEMONST_NAO = 'N';
    const IDEVENTODEMONST_SIM = 'S';
    const IDRETROCEDEVENT_SEMPRE = 'SEMPRE';
    const IDRETROCEDEVENT_NUNCA = 'NUNCA';
    const IDRETROCEDEVENT_CALCULO_PRINCIPAL = 'CALCULO_PRINCIPAL';
    const IDRETROCEDEVENT_CALCULO_ESPECIAL = 'CALCULO_ESPECIAL';
    const IDZERAEVENFECHA_NAO = 'N';
    const IDZERAEVENFECHA_SIM = 'S';
    const IDMEDIAEVENFERI_NAO = 'N';
    const IDMEDIAEVENFERI_SIM = 'S';
    const IDFALTASFERIAS_SOMA = 'SOMA';
    const IDFALTASFERIAS_SUBTRAI = 'SUBTRAI';
    const IDFALTASFERIAS_NENHUM = 'NENHUM';
    const IDFALTAS13RESC_NAO = 'N';
    const IDFALTAS13RESC_SIM = 'S';
    const IDPROCDIFRESCIS_NAO = 'N';
    const IDPROCDIFRESCIS_SIM = 'S';
    const IDPROCDIFMOVANT_NAO = 'N';
    const IDPROCDIFMOVANT_SIM = 'S';
    const IDIMPRESSEVENTO_NAO = 'N';
    const IDIMPRESSEVENTO_SIM = 'S';
    const IDTIPOOCORREVEN_EVENTUAL = 'EVENTUAL';
    const IDTIPOOCORREVEN_FIXA = 'FIXA';
    const IDTIPOOCORREVEN_PERIODICA = 'PERIODICA';
    const IDTIPOOCORREVEN_ULTIMO_PERIODO = 'ULTIMO_PERIODO';
    const IDTIPOOCORREVEN_SISTEMA = 'SISTEMA';
    const IDTIPOARREDONDA_TOTAL = 'TOTAL';
    const IDTIPOARREDONDA_PARCIAL = 'PARCIAL';
    const IDTIPOARREDONDA_TRUNCA = 'TRUNCA';
    const IDGERAVRZERO_NAO = 'N';
    const IDGERAVRZERO_SIM = 'S';
    const IDMEDIAVALREF_REFERENCIA = 'REFERENCIA';
    const IDMEDIAVALREF_VALOR = 'VALOR';
    const IDGERARATEIO_NAO = 'N';
    const IDGERARATEIO_SIM = 'S';

    public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null,$entityManager);
    }
    
    public function retornaEventoHistoricoMesCompetencia($nrEventom, $mesCompetencia){
        return Fpaeventoh::retornaHistoricoPorCompetencia($nrEventom, $mesCompetencia);
    }

    public function retornaMaximoOrdemImpressaoPorTipoEvento($idTipoEvento){
        return Fpaeventoh::retornaMaximoOrdemImpressaoPorTipoEvento($idTipoEvento);
    }

    public static function retornaUltimoHistorico($vr_link){
        $vh= null;
        $vinculos_historico = self::getObjectsByWhere(
            'NREVENTOM = ?', array($vr_link)
        );

        if (empty($vinculos_historico) !== true) {
            $vh = end($vinculos_historico);
        } else {
            MsgCalculo::getInstance()->adicionaMensagem('Evento '.$vr_link.' não cadastrado corretamente - Histórico');
        }


        return $vh;
    }

    public static function getUltimoHistorico($nreventom)
    {
        $fpaeventoh = self::getEntitiesByWhere('NREVENTOM = ?', array($nreventom), 'NREVENTOH');
        return end($fpaeventoh);
    }
    
    public function insereEventoHistorico($nreventom, $idimpressevento, $cdintegraevento, $ideventodemonst,
                                          $idfaltas13resc, $idretrocedevent, $idzeraevenfecha, $idmediaevenferi,
                                          $dtmescompetenc, $nmeventoh)
    {
        $this->setNreventom($nreventom);
        $this->setIdimpressevento($idimpressevento);
        $this->setCdintegraevento($cdintegraevento);
        $this->setIdeventodemonst($ideventodemonst);
        $this->setIdfaltas13resc($idfaltas13resc);
        $this->setIdretrocedevent($idretrocedevent);
        $this->setIdzeraevenfecha($idzeraevenfecha);
        $this->setIdmediaevenferi($idmediaevenferi);
        $this->setDtmescompetenc($dtmescompetenc);
        $this->setNmeventoh($nmeventoh);
    }
    
}

