<?php
namespace HCM\FPA\ObrigacaoLegal\Rais\Entities;

use HCM\FPA\ObrigacaoLegal\Rais\FormataMagnetico;

class Tipo00Base extends FormataMagnetico
{
    protected $sequencial;            // 06,
    protected $cnpjPrimeiro;          // 14,
    protected $prefixo;               // 02,
    protected $tipoRegistro;          // 01,
    protected $constante;             // 01,
    //EMPRESA
    protected $cnpj;                  // 14,
    protected $tipoInscricao;         // 01,
    protected $razaoSocial;           // 40,
    protected $logradouro;            // 40,
    protected $numero;                // 06,
    protected $complemento;           // 21,
    protected $bairro;                // 19,
    protected $cep;                   // 08,
    protected $codMunicipio;          // 07,
    protected $municipio;             // 30,
    protected $uf;                    // 02,
    protected $ddd;                   // 02,
    protected $numeroTel;             // 09,
    //ARQUIVO
    protected $retificacao;           // 01,
    protected $dataRetificacao;       // 08,
    protected $dataGeracao;           // 08,
    //PESSOA
    protected $emailResp;             // 45,
    protected $nomeResp;              // 52,
    protected $espacos;               // 24,
    protected $cpfResp;               // 11,
    protected $creaRetif;             // 12,
    protected $dataNascResp;          // 08,
    protected $espacos2;              // 159

    const NUM_ID_CREA = 4;
    const FORMACOMU_TEL = '01';
    const FORMACOMU_EMAIL = '05';


    public function getRow()
    {
        try {
            $row = "";
            $lengths = array(
                'cnpjPrimeiro'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'prefixo'           => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' =>  2),
                'tipoRegistro'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'constante'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'cnpj'              => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'tipoInscricao'     => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'razaoSocial'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 40),
                'logradouro'        => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 40),
                'numero'            => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'complemento'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 21),
                'bairro'            => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 19),
                'cep'               => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  8),
                'codMunicipio'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  7),
                'municipio'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 30),
                'uf'                => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' =>  2),
                'ddd'               => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  2),
                'numeroTel'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'retificacao'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'dataRetificacao'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_DIA_MES_ANO_8D, 'TAMANHO' =>  8),
                'dataGeracao'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_DIA_MES_ANO_8D, 'TAMANHO' =>  8),
                'emailResp'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 45, 'ESPECIAL' => true),
                'nomeResp'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 52),
                'espacos'           => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 24),
                'cpfResp'           => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 11),
                'creaRetif'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 12),
                'dataNascResp'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_DIA_MES_ANO_8D, 'TAMANHO' =>  8),
                'espacos2'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 192)
            );

            foreach($lengths as $name=>$length){
                $row .= $this->setData($this->$name, $length);
            }

            return $row;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public function getBairro()
    {
        return $this->bairro;
    }
    public function setBairro($bairro)
    {
        $this->bairro = $bairro;
    }
    public function getCep()
    {
        return $this->cep;
    }
    public function setCep($cep)
    {
        $this->cep = $cep;
    }
    public function getCnpj()
    {
        return $this->cnpj;
    }
    public function setCnpj($cnpj)
    {
        $this->cnpj = $cnpj;
    }
    public function getCnpjPrimeiro()
    {
        return $this->cnpjPrimeiro;
    }
    public function setCnpjPrimeiro($cnpjPrimeiro)
    {
        $this->cnpjPrimeiro = $cnpjPrimeiro;
    }
    public function getCodMunicipio()
    {
        return $this->codMunicipio;
    }
    public function setCodMunicipio($codMunicipio)
    {
        $this->codMunicipio = $codMunicipio;
    }
    public function getComplemento()
    {
        return $this->complemento;
    }
    public function setComplemento($complemento)
    {
        $this->complemento = $complemento;
    }
    public function getConstante()
    {
        return $this->constante;
    }
    public function setConstante($constante)
    {
        $this->constante = $constante;
    }
    public function getCpfResp()
    {
        return $this->cpfResp;
    }
    public function setCpfResp($cpfResp)
    {
        $this->cpfResp = $cpfResp;
    }
    public function getCreaRetif()
    {
        return $this->creaRetif;
    }
    public function setCreaRetif($creaRetif)
    {
        $this->creaRetif = $creaRetif;
    }
    public function getDataGeracao()
    {
        return $this->dataGeracao;
    }
    public function setDataGeracao($dataGeracao)
    {
        $this->dataGeracao = $dataGeracao;
    }
    public function getDataNascResp()
    {
        return $this->dataNascResp;
    }
    public function setDataNascResp($dataNascResp)
    {
        $this->dataNascResp = $dataNascResp;
    }
    public function getDataRetificacao()
    {
        return $this->dataRetificacao;
    }
    public function setDataRetificacao($dataRetificacao)
    {
        $this->dataRetificacao = $dataRetificacao;
    }
    public function getDdd()
    {
        return $this->ddd;
    }
    public function setDdd($ddd)
    {
        $this->ddd = $ddd;
    }
    public function getEmailResp()
    {
        return $this->emailResp;
    }
    public function setEmailResp($emailResp)
    {
        $this->emailResp = $emailResp;
    }
    public function getEspacos()
    {
        return $this->espacos;
    }
    public function setEspacos($espacos)
    {
        $this->espacos = $espacos;
    }
    public function getEspacos2()
    {
        return $this->espacos2;
    }
    public function setEspacos2($espacos2)
    {
        $this->espacos2 = $espacos2;
    }
    public function getLogradouro()
    {
        return $this->logradouro;
    }
    public function setLogradouro($logradouro)
    {
        $this->logradouro = $logradouro;
    }
    public function getMunicipio()
    {
        return $this->municipio;
    }
    public function setMunicipio($municipio)
    {
        $this->municipio = $municipio;
    }
    public function getNomeResp()
    {
        return $this->nomeResp;
    }
    public function setNomeResp($nomeResp)
    {
        $this->nomeResp = $nomeResp;
    }
    public function getNumero()
    {
        return $this->numero;
    }
    public function setNumero($numero)
    {
        $this->numero = $numero;
    }
    public function getNumeroTel()
    {
        return $this->numeroTel;
    }
    public function setNumeroTel($numeroTel)
    {
        $this->numeroTel = $numeroTel;
    }
    public function getPrefixo()
    {
        return $this->prefixo;
    }
    public function setPrefixo($prefixo)
    {
        $this->prefixo = $prefixo;
    }
    public function getRazaoSocial()
    {
        return $this->razaoSocial;
    }
    public function setRazaoSocial($razaoSocial)
    {
        $this->razaoSocial = $razaoSocial;
    }
    public function getRetificacao()
    {
        return $this->retificacao;
    }
    public function setRetificacao($retificacao)
    {
        $this->retificacao = $retificacao;
    }
    public function getSequencial()
    {
        return $this->sequencial;
    }
    public function setSequencial($sequencial)
    {
        $this->sequencial = $sequencial;
    }
    public function getTipoInscricao()
    {
        return $this->tipoInscricao;
    }
    public function setTipoInscricao($tipoInscricao)
    {
        $this->tipoInscricao = $tipoInscricao;
    }
    public function getTipoRegistro()
    {
        return $this->tipoRegistro;
    }
    public function setTipoRegistro($tipoRegistro)
    {
        $this->tipoRegistro = $tipoRegistro;
    }
    public function getUf()
    {
        return $this->uf;
    }
    public function setUf($uf)
    {
        $this->uf = $uf;
    }
} 