create or replace 
PROCEDURE HCM_IMPORTACAO_METADADOS (
  P_NRORG IN NUMBER
)
IS
  V_DTMESCOMPETENCIA  VARCHAR2(10) := '01/01/2000';
  V_TOTALREGISTROS    NUMBER;
  V_REGISTROSMIGRADOS NUMBER;
  V_STATUS_PENDENTE   VARCHAR2(10) := 'PENDENTE';
  V_STATUS_ANDAMENTO  VARCHAR2(10) := 'ANDAMENTO';
  V_STATUS_CONCLUIDO  VARCHAR2(10) := 'CONCLUIDO';

  /* AGRUPADORES DE IMPORTACAO */
  V_AGRUP_ESTRUTURA                VARCHAR2(30) := 'ESTRUTURA';
  V_AGRUP_OCUPACAO                 VARCHAR2(30) := 'OCUPACAO';
  V_AGRUP_ESCALA_DE_TRABALHO       VARCHAR2(30) := 'ESCALA_DE_TRABALHO';
  V_AGRUP_VINCULO                  VARCHAR2(30) := 'VINCULO';
  V_AGRUP_DEPENDENTE               VARCHAR2(30) := 'DEPENDENTE';
  V_AGRUP_ALTERACAO_SALARIAL       VARCHAR2(30) := 'ALTERACAO_SALARIAL';
  V_AGRUP_ALTERACAO_ESCALA         VARCHAR2(30) := 'ALTERACAO_ESCALA';
  V_AGRUP_ALTERACAO_OCUPACAO       VARCHAR2(30) := 'ALTERACAO_OCUPACAO';
  V_AGRUP_SITUACAO_FUNCIONAL       VARCHAR2(30) := 'SITUACAO_FUNCIONAL';
  V_AGRUP_FERIAS                   VARCHAR2(30) := 'FERIAS';
  V_AGRUP_EVENTO                   VARCHAR2(30) := 'EVENTO';
  V_AGRUP_MOV_ESTRUTURAS           VARCHAR2(30) := 'MOVIMENTACOES_ESTRUTURAS';
  V_AGRUP_MOV_FINANCEIROS          VARCHAR2(30) := 'MOVIMENTOS_FINANCEIROS';

  /* TIPOS DE ESTRUTURAS */  
  V_CENTRODECUSTO    NUMBER := 5;
  V_DEPARTAMENTO     NUMBER := 3;
  V_PROJETO          NUMBER := 9;
  V_SECAO            NUMBER := 11;
  V_TOMADOR          NUMBER := 7;
  V_EMPRESA          NUMBER := 1;
  V_FILIAL           NUMBER := 2;
  V_REGIAO           NUMBER := 8;
  V_SETOR            NUMBER := 4;
  V_PRODUTO          NUMBER := 12;
  V_SINDICATO        NUMBER := 10;
  V_PLANOSAUDE       NUMBER := 13;
  
  /* VALORES PARA MOVIMENTAES DE ESTRUTURAS */
  V_MOV_LEGAL        NUMBER := 1;
  V_MOV_GEREN        NUMBER := 2;
  V_MOTIVO_TRANS_ADM NUMBER := 2;
  V_MOTIVO_TRANS_ENT NUMBER := 8;
  V_MOTIVO_TRANS_GER NUMBER := 12;
  
  V_COUNT            NUMBER := 0;
  V_COMMIT_LIMIT     NUMBER := 10000;
   
BEGIN

  IF (P_NRORG IS NOT NULL) THEN
    
    /* APAGA OS REGISTRO DAS TABELAS */
    DELETE FROM MIG_LOG_IMPORTACAO           WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_ALTER_ESCALA    WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_ALTER_OCUPACAO  WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_ALTER_SALARIAL  WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_DEPENDENTE      WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_ESCALA_TRABALHO WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_ESTRUTURA       WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_EVENTO          WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_FERIAS          WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_MOV_ESTRUTURAS  WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_MOV_FINANCEIROS WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_OCUPACAO        WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_SITU_FUNCIONAL  WHERE NRORG = P_NRORG;
    DELETE FROM MIG_TEMPLATE_VINCULO         WHERE NRORG = P_NRORG;
    COMMIT;
    
    /* INSERE LOGS DA IMPORTACAO */    
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_ESTRUTURA, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_OCUPACAO, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_ESCALA_DE_TRABALHO, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_VINCULO, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_DEPENDENTE, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_ALTERACAO_SALARIAL, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_ALTERACAO_ESCALA, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_ALTERACAO_OCUPACAO, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_SITUACAO_FUNCIONAL, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_FERIAS, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_EVENTO, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_MOV_ESTRUTURAS, 0, 0, V_STATUS_PENDENTE);
    INSERT INTO MIG_LOG_IMPORTACAO (NRORG, DTINCLUSAO, DSAGRUPADOR, NRREGMIGRADOS, NRTOTALREGISTROS, CDSTATUS)
         VALUES (P_NRORG, SYSDATE, V_AGRUP_MOV_FINANCEIROS, 0, 0, V_STATUS_PENDENTE);
    COMMIT;    
    
    /* INCIO IMPORTAO ESTRUTURAS */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
            SELECT COUNT(1) TOTAL
              FROM RHCENTROSCUSTO1
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHCENTROSCUSTO2
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHCENTROSCUSTO3
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHCENTROSCUSTO4
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHCLIENTES
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHEMPRESAS
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHESTABELECIMENTOS
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHPOSTOSTRABALHO
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHSETORES
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHSINDICATOS
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHCONVENIOSMEDICOS
            UNION ALL
            SELECT COUNT(1) TOTAL
              FROM RHPLANOSCONVENIOS
        ) TOTAL_ESTRUTURAS;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;        
    
        /* ----------------------------- */
    
        FOR C_RHCENTROSCUSTO1 IN
          (SELECT CENTROCUSTO1, DESCRICAO40, DESCRICAO20
              FROM RHCENTROSCUSTO1)
              
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_CENTRODECUSTO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO1.CENTROCUSTO1 || V_CENTRODECUSTO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO1.DESCRICAO40,
            C_RHCENTROSCUSTO1.DESCRICAO20,
            C_RHCENTROSCUSTO1.DESCRICAO20
          );        
          
          IF (V_COUNT = V_COMMIT_LIMIT OR V_COUNT = V_TOTALREGISTROS) THEN
            
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHCENTROSCUSTO2 IN
          (SELECT CENTROCUSTO2, DESCRICAO40, DESCRICAO20
              FROM RHCENTROSCUSTO2)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_DEPARTAMENTO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO2.CENTROCUSTO2 || V_DEPARTAMENTO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO2.DESCRICAO40,
            C_RHCENTROSCUSTO2.DESCRICAO20,
            C_RHCENTROSCUSTO2.DESCRICAO20
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */
          
        FOR C_RHCENTROSCUSTO3 IN
          (SELECT CENTROCUSTO3, DESCRICAO40, DESCRICAO20
              FROM RHCENTROSCUSTO3)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_PROJETO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO3.CENTROCUSTO3 || V_PROJETO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO3.DESCRICAO40,
            C_RHCENTROSCUSTO3.DESCRICAO20,
            C_RHCENTROSCUSTO3.DESCRICAO20
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHCENTROSCUSTO4 IN
          (SELECT CENTROCUSTO4, DESCRICAO40, DESCRICAO20
              FROM RHCENTROSCUSTO4)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_SECAO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO4.CENTROCUSTO4 || V_SECAO,
            V_DTMESCOMPETENCIA,
            C_RHCENTROSCUSTO4.DESCRICAO40,
            C_RHCENTROSCUSTO4.DESCRICAO20,
            C_RHCENTROSCUSTO4.DESCRICAO20
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */  
        
        FOR C_RHCLIENTES IN
          (SELECT CLIENTE, DESCRICAO40, NOMEREDUZIDO, TIPOINSCRICAO, INSCRICAO, RUA, NRORUA, COMPLEMENTO, BAIRRO, 
                  CIDADE, CEP, UF, DDD, TELEFONE, RAMAL, DDDFAX, TELEFONEFAX, RAMALFAX, EMAIL, CONTATO
              FROM RHCLIENTES)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, CNPJ, RAZAO_SOCIAL, ESTADO, MUNICIPIO, ENDERECO, NUMERO, NOME_DO_BAIRRO, CEP, REFERENCIA_DO_ENDERECO, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_PRODUTO,
            V_DTMESCOMPETENCIA,
            C_RHCLIENTES.CLIENTE || V_PRODUTO,
            V_DTMESCOMPETENCIA,
            C_RHCLIENTES.INSCRICAO,
            C_RHCLIENTES.DESCRICAO40,
            C_RHCLIENTES.UF,
            C_RHCLIENTES.CIDADE,
            C_RHCLIENTES.RUA,
            C_RHCLIENTES.NRORUA,
            C_RHCLIENTES.BAIRRO,
            C_RHCLIENTES.CEP,
            C_RHCLIENTES.COMPLEMENTO,
            C_RHCLIENTES.NOMEREDUZIDO,
            C_RHCLIENTES.NOMEREDUZIDO      
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */  
          
        FOR C_RHEMPRESAS IN
          (SELECT EMPRESA, RAZAOSOCIAL, DESCRICAO20
              FROM RHEMPRESAS)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_EMPRESA,
            V_DTMESCOMPETENCIA,
            C_RHEMPRESAS.EMPRESA || V_EMPRESA,
            V_DTMESCOMPETENCIA,
            C_RHEMPRESAS.RAZAOSOCIAL,
            C_RHEMPRESAS.DESCRICAO20,
            C_RHEMPRESAS.DESCRICAO20
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */  
          
        FOR C_RHESTABELECIMENTOS IN
          (SELECT ESTABELECIMENTO, RAZAOSOCIAL, DESCRICAO20, REPLACE(NATUREZAJURIDICA, '-', '') NATUREZAJURIDICA, INSCRICAO, CNAE, RUA,
                  NRORUA, COMPLEMENTO, BAIRRO, CIDADE, CEP, UF, DECODE(OPTANTEPELOSIMPLES, '1', 'S', '2', 'N') OPTANTEPELOSIMPLES, PARTICIPAPAT       
             FROM RHESTABELECIMENTOS)
          
        LOOP
          
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, CNPJ, RAZAO_SOCIAL, NATUREZA_JURIDICA, CNAE, OPTANTE_SIMPLES, PARTICIPACAO_PAT, ESTADO, MUNICIPIO, ENDERECO, NUMERO, NOME_DO_BAIRRO, CEP, REFERENCIA_DO_ENDERECO, NOME_FANTASIA, NOME_ESTRUTURA)
          VALUES (
            P_NRORG,
            SYSDATE,
            V_FILIAL,
            V_DTMESCOMPETENCIA,
            C_RHESTABELECIMENTOS.ESTABELECIMENTO || V_FILIAL,
            V_DTMESCOMPETENCIA,        
            C_RHESTABELECIMENTOS.INSCRICAO,
            C_RHESTABELECIMENTOS.RAZAOSOCIAL,
            C_RHESTABELECIMENTOS.NATUREZAJURIDICA,
            C_RHESTABELECIMENTOS.CNAE,
            C_RHESTABELECIMENTOS.OPTANTEPELOSIMPLES,
            C_RHESTABELECIMENTOS.PARTICIPAPAT,
            C_RHESTABELECIMENTOS.UF,
            C_RHESTABELECIMENTOS.CIDADE,
            C_RHESTABELECIMENTOS.RUA,
            C_RHESTABELECIMENTOS.NRORUA,
            C_RHESTABELECIMENTOS.BAIRRO,
            C_RHESTABELECIMENTOS.CEP,
            C_RHESTABELECIMENTOS.COMPLEMENTO,
            C_RHESTABELECIMENTOS.DESCRICAO20,
            C_RHESTABELECIMENTOS.DESCRICAO20
          );
          
          IF (V_COUNT = V_COMMIT_LIMIT) THEN
          
            /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
            UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
            COMMIT;  
            
            V_COUNT := 0;
          ELSE
            V_COUNT := V_COUNT + 1;
          END IF;
          
        END LOOP;
          
        /* ----------------------------------------------------------------------------------------- */   
        
        FOR C_RHPOSTOSTRABALHO IN
          (SELECT POSTOTRABALHO, DESCRICAO40, DESCRICAO20, TELEFONE
             FROM RHPOSTOSTRABALHO)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_REGIAO,
              V_DTMESCOMPETENCIA,
              C_RHPOSTOSTRABALHO.POSTOTRABALHO || V_REGIAO,
              V_DTMESCOMPETENCIA,
              C_RHPOSTOSTRABALHO.DESCRICAO40,
              C_RHPOSTOSTRABALHO.DESCRICAO20,
              C_RHPOSTOSTRABALHO.DESCRICAO20
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
            
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHSETORES IN
          (SELECT SETOR, DESCRICAO40, DESCRICAO20
             FROM RHSETORES)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_SETOR,
              V_DTMESCOMPETENCIA,
              C_RHSETORES.SETOR || V_SETOR,
              V_DTMESCOMPETENCIA,
              C_RHSETORES.DESCRICAO40,
              C_RHSETORES.DESCRICAO20,
              C_RHSETORES.DESCRICAO20
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHSINDICATOS IN
          (SELECT SINDICATO, DESCRICAO60, DESCRICAO40, DESCRICAO20, INSCRICAO, RUA, NRORUA, COMPLEMENTO, BAIRRO, CEP, UF, CIDADE
             FROM RHSINDICATOS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, CNPJ, RAZAO_SOCIAL, ESTADO, MUNICIPIO, ENDERECO, NUMERO, NOME_DO_BAIRRO, CEP, REFERENCIA_DO_ENDERECO, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_SINDICATO,
              V_DTMESCOMPETENCIA,
              C_RHSINDICATOS.SINDICATO || V_SINDICATO,
              V_DTMESCOMPETENCIA,
              C_RHSINDICATOS.INSCRICAO,
              C_RHSINDICATOS.DESCRICAO60,
              C_RHSINDICATOS.UF,
              C_RHSINDICATOS.CIDADE,
              C_RHSINDICATOS.RUA,
              C_RHSINDICATOS.NRORUA,
              C_RHSINDICATOS.BAIRRO,
              C_RHSINDICATOS.CEP,
              C_RHSINDICATOS.COMPLEMENTO,
              C_RHSINDICATOS.DESCRICAO20,
              C_RHSINDICATOS.DESCRICAO40
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
            
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHUNIDADES IN
          (SELECT UNIDADE, DESCRICAO40, DESCRICAO20
             FROM RHUNIDADES)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_TOMADOR,
              V_DTMESCOMPETENCIA,
              C_RHUNIDADES.UNIDADE || V_TOMADOR,
              V_DTMESCOMPETENCIA,
              C_RHUNIDADES.DESCRICAO40,
              C_RHUNIDADES.DESCRICAO20,
              C_RHUNIDADES.DESCRICAO20
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
            
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHCONVENIOSMEDICOS IN
          (SELECT CONVENIO, RAZAOSOCIAL, DESCRICAO20, INSCRICAO, RUA, NRORUA, COMPLEMENTO, BAIRRO, CIDADE, CEP, UF
             FROM RHCONVENIOSMEDICOS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, CNPJ, RAZAO_SOCIAL, ESTADO, MUNICIPIO, ENDERECO, NUMERO, NOME_DO_BAIRRO, CEP, REFERENCIA_DO_ENDERECO, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_PLANOSAUDE,
              V_DTMESCOMPETENCIA,
              C_RHCONVENIOSMEDICOS.CONVENIO || V_PLANOSAUDE,
              V_DTMESCOMPETENCIA,
              C_RHCONVENIOSMEDICOS.INSCRICAO,
              C_RHCONVENIOSMEDICOS.RAZAOSOCIAL,
              C_RHCONVENIOSMEDICOS.UF,
              C_RHCONVENIOSMEDICOS.CIDADE,
              C_RHCONVENIOSMEDICOS.RUA,
              C_RHCONVENIOSMEDICOS.NRORUA,
              C_RHCONVENIOSMEDICOS.BAIRRO,
              C_RHCONVENIOSMEDICOS.CEP,
              C_RHCONVENIOSMEDICOS.COMPLEMENTO,
              C_RHCONVENIOSMEDICOS.DESCRICAO20,
              C_RHCONVENIOSMEDICOS.DESCRICAO20
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
            
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHPLANOSCONVENIOS IN
          (SELECT CONVENIO, DESCRICAO40, DESCRICAO20
             FROM RHPLANOSCONVENIOS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESTRUTURA (NRORG, DTINCLUSAO, TIPO_DE_ESTRUTURA, INICIO_DE_VIGENCIA, N_ESTRUTURA, MES_COMPETENCIA, RAZAO_SOCIAL, NOME_FANTASIA, NOME_ESTRUTURA)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_PLANOSAUDE,
              V_DTMESCOMPETENCIA,
              C_RHPLANOSCONVENIOS.CONVENIO || V_PLANOSAUDE,
              V_DTMESCOMPETENCIA,
              C_RHPLANOSCONVENIOS.DESCRICAO40,
              C_RHPLANOSCONVENIOS.DESCRICAO20,
              C_RHPLANOSCONVENIOS.DESCRICAO20
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
            
              /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */
              UPDATE MIG_LOG_IMPORTACAO SET NRREGMIGRADOS = V_COUNT WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
              COMMIT;  
              
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESTRUTURA;
        
    /* FIM IMPORTAO ESTRUTURAS */    
    
    /* INICIO IMPORTAO OCUPAES */    
    
      /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
      SELECT SUM(TOTAL) 
        INTO V_TOTALREGISTROS
        FROM (
          SELECT COUNT(1) TOTAL
           FROM RHCARGOS
          UNION ALL
          SELECT COUNT(1) TOTAL
           FROM RHFUNCOES
      ) TOTAL_OCUPACOES;
      
      /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
      UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_OCUPACAO;
  
      /* ----------------------------- */
    
      FOR C_RHCARGOS IN
          (SELECT CARGO, DESCRICAO40, DESCRICAO20, DESCRICAOOFICIAL, CBONOVO
             FROM RHCARGOS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_OCUPACAO (NRORG, DTINCLUSAO, TP_OCUPACAO, INICIO_VIGENCIA, NR_OCUPACAO, COMPETENCIA, DESCRICAO, CBO)
            VALUES (
              P_NRORG,
              SYSDATE,
              1,
              V_DTMESCOMPETENCIA,
              C_RHCARGOS.CARGO,
              V_DTMESCOMPETENCIA,
              C_RHCARGOS.DESCRICAOOFICIAL,
              C_RHCARGOS.CBONOVO
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHFUNCOES IN
          (SELECT FUNCAO, DESCRICAO40, DESCRICAO20, CBONOVO
             FROM RHFUNCOES)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_OCUPACAO (NRORG, DTINCLUSAO, TP_OCUPACAO, INICIO_VIGENCIA, NR_OCUPACAO, COMPETENCIA, DESCRICAO, CBO)
            VALUES (
              P_NRORG,
              SYSDATE,
              2,
              V_DTMESCOMPETENCIA,
              C_RHFUNCOES.FUNCAO || P_NRORG,
              V_DTMESCOMPETENCIA,
              C_RHFUNCOES.DESCRICAO40,
              C_RHFUNCOES.CBONOVO
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_OCUPACAO;
    
    /* FIM IMPORTAO OCUPAES */    
    
    /* INICIO IMPORTAO ESCALAS DE TRABALHO */  
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
            SELECT COUNT(1) TOTAL
              FROM RHESCALAS
        ) TOTAL_ESCALAS;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESCALA_DE_TRABALHO;
    
        /* ----------------------------- */
    
        FOR C_RHESCALAS IN
          (SELECT ESCALA, DESCRICAO60, DESCRICAO40, HORASSEMANA, INICIOVALIDADE
             FROM RHESCALAS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ESCALA_TRABALHO (NRORG, DTINCLUSAO, INICIO_VIGENCIA, NR_ESCALA, COMPETENCIA, NOME)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHESCALAS.INICIOVALIDADE,
              C_RHESCALAS.ESCALA,
              V_DTMESCOMPETENCIA,
              C_RHESCALAS.DESCRICAO40
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ESCALA_DE_TRABALHO;
    
    /* FIM IMPORTAO ESCALAS DE TRABALHO */  
    
    /* INICIO IMPORTAO HORARIOS */  
    /* FIM IMPORTAO HORARIOS */  
    
    /* INICIO IMPORTAO INTERVALOS HORARIOS */  
    /* FIM IMPORTAO INTERVALOS HORARIOS */
    
    /* INICIO IMPORTAO TURNOS */  
    /* FIM IMPORTAO TURNOS */
    
    /* INICIO IMPORTAO HORARIOS TURNOS */  
    /* FIM IMPORTAO HORARIOS TURNOS */  
    
    /* INICIO IMPORTAO VINCULOS */  
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
            SELECT COUNT(1) TOTAL
                FROM RHCONTRATOS 
                JOIN RHPESSOAS
                  ON RHPESSOAS.PESSOA  = RHCONTRATOS.PESSOA
                 AND RHPESSOAS.EMPRESA = RHCONTRATOS.EMPRESA
                LEFT JOIN RHBANCOS
                  ON RHBANCOS.BANCO = RHCONTRATOS.BANCOCREDOR
               WHERE 1 = 1 
               ORDER BY CONTRATO, UNIDADE
        ) TOTAL_VINCULOS;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_VINCULO;
    
        /* ----------------------------- */
    
        FOR C_RHPESSOAS IN
          (SELECT RHPESSOAS.EMPRESA, UNIDADE, RHCONTRATOS.SETOR, RHCONTRATOS.ESTABELECIMENTO, CONTRATO, RHPESSOAS.PESSOA, RHPESSOAS.NOME, RHPESSOAS.NOMECOMPLETO, 
                   DECODE(SITUACAO, '3', '13', '4', '13', SITUACAO) SITUACAO,        
                   DECODE(CAUSARESCISAOFOLHA, '1', '1', '2', '2', '3', '4', '4', '5', '5', '3', '6', '7', '7', '13', '8', '10', '9', '26', '1') CAUSARESCISAOFOLHA,        
                   DATAADMISSAO, 
                   DECODE(TIPOEMPREGO, '6', '2', '7', '2', '8', '2', '9', '2', TIPOEMPREGO) TIPOEMPREGO,
                   DECODE(TIPOSALARIO, '1', 'MENSAL', '2', 'QUINZENAL', '3', 'SEMANAL', '4', 'DIARIO', '5', 'HORA', '6', 'TAREFA', 'MENSAL') TIPOSALARIO,
                   DECODE(VINCULOEMPREGATICIO, '09', 'AUTONOMO', '13', 'ESTAGIO', 'SAL1_RSR') TIPOREMUNERACAO,
                   '2' TIPOCONTACORRENTE,
                   'UNICO' MULTIPLOSVINCULOS,
                   '1' MODALIDADESALARIO,
                   BANCOCREDOR, RHBANCOS.NROBANCO, RHBANCOS.AGENCIA, CONTACORRENTE, 
                   DECODE(VINCULOPREVIDENCIA, '8', '2', '3', '6', '1') VINCULOPREVIDENCIA,
                   DATAOPCAOFGTS, 
                   DECODE(OPCAOSINDICAL, '0', 'NUNCA', '1', 'DESCONTOU', '2', 'SEMPRE') OPCAOSINDICAL,
                   NRODIASCONTRATO, TERMINOPRORROGACAO, NRODIASPRORROGACAO, DATAAVISOPREVIO, DATARESCISAO, DATAEXAMEMEDICO, CARGO, ESCALA, 
                   DECODE(VINCULOEMPREGATICIO, 
                          '01', '2', 
                          '02', '11', 
                          '03', '7', 
                          '04', '8', 
                          '05', '15', 
                          '06', '4', 
                          '07', '14', 
                          '08', '14', 
                          '09', '21', 
                          '10', '21', 
                          '11', '22', 
                          '12', '19', 
                          '13', '20', 
                          '14', '9', 
                          '15', '1',
                          '16', '2', 
                          '17', '6', 
                          '18', '2', 
                          '19', '2', 
                          '20', '2', 
                          '21', '1', 
                          '22', '21', 
                          '26', '13', 
                          '2') VINCULOEMPREGATICIO,
                   FUNCAO, RHPESSOAS.NASCIMENTO, RHPESSOAS.LOCALNASCIMENTO, RHPESSOAS.UFNASCIMENTO, RHPESSOAS.SEXO, 
                   DECODE(RHPESSOAS.RACACOR, '1', '1', '2', '2', '4', '3', '6', '4', '8', '5', '9', '6') RACACOR, 
                   RHPESSOAS.RUA, RHPESSOAS.NRORUA, RHPESSOAS.COMPLEMENTO, RHPESSOAS.BAIRRO, RHPESSOAS.CIDADE, RHPESSOAS.CEP, RHPESSOAS.UF, RHPESSOAS.NROCARTTRAB, RHPESSOAS.SERIECARTTRAB, RHPESSOAS.DATACARTTRAB, RHPESSOAS.UFCARTTRAB, RHPESSOAS.PIS, RHPESSOAS.DATAPIS, RHPESSOAS.CPF, RHPESSOAS.IDENTIDADE, RHPESSOAS.DATAIDENTIDADE, RHPESSOAS.ORGAOEMISSOR, RHPESSOAS.UFIDENTIDADE, RHPESSOAS.TITULOELEITORAL, RHPESSOAS.ZONAELEITORAL, RHPESSOAS.SECAOELEITORAL, RHPESSOAS.REGISTROHABILITACAO, RHPESSOAS.VALIDADEHABILITACAO, RHPESSOAS.CATEGORIAHABILITACAO, RHPESSOAS.DATAAPOSENTADORIA, 
                   DECODE(RHPESSOAS.ESTADOCIVIL, '01', 'S', '02', 'C', '03', 'V', '04', 'I', '05', 'I', '06', 'O', '07', 'O') ESTADOCIVIL,
                   DECODE(RHPESSOAS.GRAUINSTRUCAO,
                          '01', '1',
                          '02', '4',
                          '03', '4',
                          '04', '4',
                          '05', '5',
                          '06', '6',
                          '07', '7',
                          '08', '8',
                          '09', '9',
                          '10', '10',
                          '11', '10',
                          '12', '12') GRAUINSTRUCAO,
                   DECODE(RHPESSOAS.PAISNASCIMENTO, '105', '0055') PAISNASCIMENTO, 
                   DECODE(RHPESSOAS.PAISNACIONALIDADE, '105', '0055') PAISNACIONALIDADE, 
                   DECODE(RHPESSOAS.PAISRESIDENCIA, '105', '0055') PAISRESIDENCIA,
                   RHCONTRATOS.SINDICATO
              FROM RHCONTRATOS 
              JOIN RHPESSOAS
                ON RHPESSOAS.PESSOA  = RHCONTRATOS.PESSOA
               AND RHPESSOAS.EMPRESA = RHCONTRATOS.EMPRESA
              LEFT JOIN RHBANCOS
                ON RHBANCOS.BANCO = RHCONTRATOS.BANCOCREDOR
             WHERE 1 = 1 
             ORDER BY CONTRATO, UNIDADE)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_VINCULO (NRORG, DTINCLUSAO, DATA_ADMISSAO, DATA_RESCISAO, NR_VINCULO, SITU_FUNCIONAL, ESCALA_TRABALHO, MES_COMPETENCIA, CONTRIBUICAO_SIND, NOME, ESTADO_CIVIL, CPF, CTPS, SERIE_CTPS, UF_CTPS, EMISSAO_CTPS, PIS_PASEP, DATA_DE_CADASTRO_DO_PIS, CARTEIRA_DE_IDENTIDADE, ORGAO_EMISSOR_CART_DE_IDENTID, UF_CARTEIRA_IDENTIDADE, DATA_EMISSAO_CART_DE_IDENTID, TITULO_DE_ELEITOR, SECAO_DE_VOTACAO, ZONA_DE_VOTACAO, CNH, VENCIMENTO_CNH, TIPO_CNH, RACA, PAIS, ESTADO, NATURALIDADE, DATA_DE_NASCIMENTO, SEXO, TIPO_REMUNERACAO, BANCO, AGENCIA, CONTA_CORRENTE, TP_CONTA_CORRENTE, NACIONALIDADE, TP_PAGAMENTO, ESTRUTURA_TRABALHO, ESTRUTURA_GERENCIAL, PAIS_END, ESTADO_END, MUNICIPIO_END, ENDERECO, NUMERO, NOME_DO_BAIRRO, COMPLEMENTO, TIPO_VINCULO_MESTRE, TIPO_DE_DEMISSAO, DATA_FGTS, DT_APOSENTADORIA_FGTS, OCUPACAO, MULTIPLOS_VINCULOS, DATA_AVISO_PREVIO, FIM_CONTRATO_DETERMINADO, VINCULO_EMPREGATICIO, TIPO_ADMISSAO, MODALIDADE_SALARIO, GRAU_INSTRUCAO, DIAS_CONTRATO_EXP, DIAS_CONTRATO_EXP_PRORR, DT_EXAME_MEDICO, CEP, ESTRUTURA_SINDICAL)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHPESSOAS.DATAADMISSAO,
              C_RHPESSOAS.DATARESCISAO,
              C_RHPESSOAS.EMPRESA || C_RHPESSOAS.PESSOA,
              C_RHPESSOAS.SITUACAO,
              C_RHPESSOAS.ESCALA,
              V_DTMESCOMPETENCIA,
              C_RHPESSOAS.OPCAOSINDICAL,
              C_RHPESSOAS.NOMECOMPLETO,
              C_RHPESSOAS.ESTADOCIVIL,
              C_RHPESSOAS.CPF,
              C_RHPESSOAS.NROCARTTRAB,
              C_RHPESSOAS.SERIECARTTRAB,
              C_RHPESSOAS.UFCARTTRAB,
              C_RHPESSOAS.DATACARTTRAB,
              C_RHPESSOAS.PIS,
              C_RHPESSOAS.DATAPIS,
              C_RHPESSOAS.IDENTIDADE,
              C_RHPESSOAS.ORGAOEMISSOR,
              C_RHPESSOAS.UFIDENTIDADE,
              C_RHPESSOAS.DATAIDENTIDADE,
              C_RHPESSOAS.TITULOELEITORAL,
              C_RHPESSOAS.SECAOELEITORAL,
              C_RHPESSOAS.ZONAELEITORAL,
              C_RHPESSOAS.REGISTROHABILITACAO,
              C_RHPESSOAS.VALIDADEHABILITACAO,
              C_RHPESSOAS.CATEGORIAHABILITACAO,
              C_RHPESSOAS.RACACOR,
              C_RHPESSOAS.PAISNASCIMENTO,
              C_RHPESSOAS.UFNASCIMENTO,
              C_RHPESSOAS.LOCALNASCIMENTO,
              C_RHPESSOAS.NASCIMENTO,
              C_RHPESSOAS.SEXO,
              C_RHPESSOAS.TIPOREMUNERACAO,
              C_RHPESSOAS.NROBANCO,
              C_RHPESSOAS.AGENCIA,
              C_RHPESSOAS.CONTACORRENTE,
              C_RHPESSOAS.TIPOCONTACORRENTE,
              C_RHPESSOAS.PAISNACIONALIDADE,
              C_RHPESSOAS.TIPOSALARIO,
              C_RHPESSOAS.ESTABELECIMENTO || V_FILIAL,
              C_RHPESSOAS.SETOR || V_SETOR,
              C_RHPESSOAS.PAISRESIDENCIA,
              C_RHPESSOAS.UF,
              C_RHPESSOAS.CIDADE,
              C_RHPESSOAS.RUA,
              C_RHPESSOAS.NRORUA,
              C_RHPESSOAS.BAIRRO,
              C_RHPESSOAS.COMPLEMENTO,
              C_RHPESSOAS.VINCULOPREVIDENCIA,
              C_RHPESSOAS.CAUSARESCISAOFOLHA,
              C_RHPESSOAS.DATAOPCAOFGTS,
              C_RHPESSOAS.DATAAPOSENTADORIA,
              C_RHPESSOAS.CARGO,
              C_RHPESSOAS.MULTIPLOSVINCULOS,
              C_RHPESSOAS.DATAAVISOPREVIO,
              C_RHPESSOAS.TERMINOPRORROGACAO,
              C_RHPESSOAS.VINCULOEMPREGATICIO,
              C_RHPESSOAS.TIPOEMPREGO,
              C_RHPESSOAS.MODALIDADESALARIO,
              C_RHPESSOAS.GRAUINSTRUCAO,
              C_RHPESSOAS.NRODIASCONTRATO,
              C_RHPESSOAS.NRODIASPRORROGACAO,
              C_RHPESSOAS.DATAEXAMEMEDICO,
              C_RHPESSOAS.CEP,
              C_RHPESSOAS.SINDICATO || V_SINDICATO
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_VINCULO;
    
    /* FIM IMPORTAO VINCULOS */
    
    /* INICIO IMPORTAO DEPENDENTES */
      
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
            SELECT COUNT(1) TOTAL
               FROM RHPENSIONISTAS
            UNION ALL
            SELECT COUNT(1) TOTAL
                FROM RHFAMILIARES
        ) TOTAL_DEPENDENTES;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_DEPENDENTE;
    
        /* ----------------------------- */
      
        FOR C_RHPENSIONISTAS IN
          (SELECT EMPRESA, PESSOA, NOME, NASCIMENTO, SEXO, CPF, IDENTIDADE, UF
             FROM RHPENSIONISTAS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_DEPENDENTE (NRORG, DTINCLUSAO, TIPO_DE_RELACIONAMENTO, NR_VINCULO, COMPETENCIA, NOME, CPF, RG, UF, DT_NASCIMENTO, SEXO, TIPO_DEPENDENCIA)
            VALUES (
              P_NRORG,
              SYSDATE,
              '6', /* TIPO DE RELACIONAMENTO DE PESIONISTAS */
              C_RHPENSIONISTAS.EMPRESA || C_RHPENSIONISTAS.PESSOA,
              V_DTMESCOMPETENCIA,
              C_RHPENSIONISTAS.NOME,
              C_RHPENSIONISTAS.CPF,
              C_RHPENSIONISTAS.IDENTIDADE,
              C_RHPENSIONISTAS.UF,
              C_RHPENSIONISTAS.NASCIMENTO,
              C_RHPENSIONISTAS.SEXO,
              '3' /* TIPO DE DEPENDNCIA NA FOLHA - PENSO JUDICAL */
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ----------------------------------------------------------------------------------------- */
    
        FOR C_RHFAMILIARES IN
          (SELECT EMPRESA, PESSOA, NOME, NASCIMENTO, SEXO, CPF, IDENTIDADE, UFIDENTIDADE, SALFAMILIA, DEPENDENTEIRF, DECODE(SALFAMILIA, 'S', '1') TIPODEPENDENCIA,
                   CASE 
                      WHEN GRAUPARENTESCO = '5' AND SEXO = 'M' THEN '2'
                      WHEN GRAUPARENTESCO = '5' AND SEXO = 'F' THEN '1'
                      ELSE DECODE(GRAUPARENTESCO, '1', '3', '4', '4', '6', '9') 
                   END GRAUPARENTESCO
              FROM RHFAMILIARES
              
            UNION
            
            SELECT EMPRESA, PESSOA, NOME, NASCIMENTO, SEXO, CPF, IDENTIDADE, UFIDENTIDADE, SALFAMILIA, DEPENDENTEIRF, DECODE(DEPENDENTEIRF, 'S', '2') TIPODEPENDENCIA,
                   CASE 
                      WHEN GRAUPARENTESCO = '5' AND SEXO = 'M' THEN '2' /* PAI */
                      WHEN GRAUPARENTESCO = '5' AND SEXO = 'F' THEN '1' /* ME */
                      ELSE DECODE(GRAUPARENTESCO, '1', '3', '4', '4', '6', '9') 
                   END GRAUPARENTESCO
              FROM RHFAMILIARES)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_DEPENDENTE (NRORG, DTINCLUSAO, TIPO_DE_RELACIONAMENTO, NR_VINCULO, COMPETENCIA, NOME, CPF, RG, UF, DT_NASCIMENTO, SEXO, TIPO_DEPENDENCIA)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHFAMILIARES.GRAUPARENTESCO,
              C_RHFAMILIARES.EMPRESA || C_RHFAMILIARES.PESSOA,
              V_DTMESCOMPETENCIA,
              C_RHFAMILIARES.NOME,
              C_RHFAMILIARES.CPF,
              C_RHFAMILIARES.IDENTIDADE,
              C_RHFAMILIARES.UFIDENTIDADE,
              C_RHFAMILIARES.NASCIMENTO,
              C_RHFAMILIARES.SEXO,
              C_RHFAMILIARES.TIPODEPENDENCIA
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_DEPENDENTE;
    
    /* FIM IMPORTAO DEPENDENTES */
    
    /* INICIO IMPORTAO ALTERAO SALARIAL */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
               FROM RHALTERACOESSALARIO
               JOIN RHCONTRATOS
                 ON RHCONTRATOS.CONTRATO = RHALTERACOESSALARIO.CONTRATO
                AND RHCONTRATOS.UNIDADE  = RHALTERACOESSALARIO.UNIDADE
             UNION ALL
             SELECT COUNT(1) TOTAL
               FROM RHCONTRATOS
        ) TOTAL_ALTESALARIO;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_SALARIAL;
    
        /* ----------------------------- */
    
        FOR C_RHALTERACOESSALARIO IN
          (SELECT RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHALTERACOESSALARIO.DATAHORA, 
                  DECODE(RHALTERACOESSALARIO.TIPOSALARIO, '1', 'MENSAL', '2', 'QUINZENAL', '3', 'SEMANAL', '4', 'DIARIO', '5', 'HORA', '6', 'TAREFA', 'MENSAL') TIPOSALARIO,
                  RHALTERACOESSALARIO.SALARIOCONTRATUAL, 
                  DECODE(RHALTERACOESSALARIO.MOTIVOALTSALARIO,
                         '01', '4',
                         '02', '3',
                         '03', '7',
                         '04', '7',
                         '05', '12',
                         '06', '12',
                         '07', '2',
                         '08', '7',
                         '09', '14',
                         '10', '7',
                         '11', '22',
                         '12', '1',
                         '13', '8',
                         '99', '22') MOTIVOALTSALARIO
             FROM RHALTERACOESSALARIO
             JOIN RHCONTRATOS
               ON RHCONTRATOS.CONTRATO = RHALTERACOESSALARIO.CONTRATO
              AND RHCONTRATOS.UNIDADE  = RHALTERACOESSALARIO.UNIDADE)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ALTER_SALARIAL (NRORG, DTINCLUSAO, NR_VINCULO, DT_ALTERACAO, NUMERO_OCORRENCIA, TIPO_ALTERACAO, SALARIO, TIPO_SALARIO)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHALTERACOESSALARIO.EMPRESA || C_RHALTERACOESSALARIO.PESSOA,
              C_RHALTERACOESSALARIO.DATAHORA,
              '1',
              C_RHALTERACOESSALARIO.MOTIVOALTSALARIO,
              C_RHALTERACOESSALARIO.SALARIOCONTRATUAL,
              C_RHALTERACOESSALARIO.TIPOSALARIO
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ----------------------------------------------------------------------------------------- */
    
        FOR C_RHCONTRATOS IN
          (SELECT EMPRESA, PESSOA, SALARIOMES, NVL(DATAULTIMOREAJUSTE, DATAADMISSAO) DATAALTERACAO, 
                  DECODE(TIPOSALARIO, '1', 'MENSAL', '2', 'QUINZENAL', '3', 'SEMANAL', '4', 'DIARIO', '5', 'HORA', '6', 'TAREFA', 'MENSAL') TIPOSALARIO
             FROM RHCONTRATOS)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ALTER_SALARIAL (NRORG, DTINCLUSAO, NR_VINCULO, DT_ALTERACAO, NUMERO_OCORRENCIA, TIPO_ALTERACAO, SALARIO, TIPO_SALARIO)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHCONTRATOS.EMPRESA || C_RHCONTRATOS.PESSOA,
              C_RHCONTRATOS.DATAALTERACAO,
              '1',
              '22',
              C_RHCONTRATOS.SALARIOMES,
              C_RHCONTRATOS.TIPOSALARIO
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_SALARIAL;
    
    /* FIM IMPORTAO ALTERAO SALARIAL */
    
    /* INICIO IMPORTAO ALTERAO DE OCUPAO */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
                FROM RHALTERACOESCONTRATO
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
               WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CCAR'
        ) TOTAL_ALTEOCUPACAO;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_OCUPACAO;
    
        /* ----------------------------- */
    
        FOR C_RHALTERACOESCONTRATO IN
          (SELECT CONTRATO, EMPRESA, PESSOA, DATAADMISSAO AS DATAHORAALTERACAO, VARIAVEL, NULL AS CODIGOANTERIOR, CODIGOANTERIOR AS CODIGOATUAL, NULL AS CONTEUDOANTERIOR, CONTEUDOANTERIOR AS CONTEUDOATUAL
              FROM (SELECT ROW_NUMBER() OVER(PARTITION BY RHALTERACOESCONTRATO.CONTRATO ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) AS SEQUENCIAL, 
                           RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHCONTRATOS.DATAADMISSAO, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL
                      FROM RHALTERACOESCONTRATO
                      JOIN RHCONTRATOS
                        ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                       AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
                     WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CCAR' 
                     ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) ALTERACOES
             WHERE SEQUENCIAL = 1
             
            UNION ALL
            
            SELECT RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL
              FROM RHALTERACOESCONTRATO
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
             WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CCAR')
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ALTER_OCUPACAO (NRORG, DTINCLUSAO, NR_VINCULO, DT_ALTERACAO, OCUPACAO)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHALTERACOESCONTRATO.EMPRESA || C_RHALTERACOESCONTRATO.PESSOA,
              TRUNC(C_RHALTERACOESCONTRATO.DATAHORAALTERACAO),
              C_RHALTERACOESCONTRATO.CODIGOATUAL
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;    
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_OCUPACAO;
    
    /* FIM IMPORTAO ALTERAO DE OCUPAO */
    
    /* INICIO IMPORTAO ALTERAO ESCALA DE TRABALHO */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
                FROM RHALTERACOESCONTRATO
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
               WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CESC'
        ) TOTAL_ALTEESCALA;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_ESCALA;
    
        /* ----------------------------- */
    
        FOR C_RHALTERACOESESCALA IN
          (SELECT CONTRATO, EMPRESA, PESSOA, DATAADMISSAO AS DATAHORAALTERACAO, VARIAVEL, NULL AS CODIGOANTERIOR, CODIGOANTERIOR AS CODIGOATUAL, NULL AS CONTEUDOANTERIOR, CONTEUDOANTERIOR AS CONTEUDOATUAL
              FROM (SELECT ROW_NUMBER() OVER(PARTITION BY RHALTERACOESCONTRATO.CONTRATO ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) AS SEQUENCIAL, 
                           RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHCONTRATOS.DATAADMISSAO, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL
                      FROM RHALTERACOESCONTRATO
                      JOIN RHCONTRATOS
                        ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                       AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
                     WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CESC' 
                     ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) ALTERACOES
             WHERE SEQUENCIAL = 1
             
            UNION ALL
            
            SELECT RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL
              FROM RHALTERACOESCONTRATO
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
             WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CESC')
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_ALTER_ESCALA (NRORG, DTINCLUSAO, NR_VINCULO, DT_ALTERACAO, ESCALA)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHALTERACOESESCALA.EMPRESA || C_RHALTERACOESESCALA.PESSOA,
              TRUNC(C_RHALTERACOESESCALA.DATAHORAALTERACAO),
              C_RHALTERACOESESCALA.CODIGOATUAL
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_ALTERACAO_ESCALA;
    
    /* FIM IMPORTAO ALTERAO ESCALA DE TRABALHO */
    
    /* INICIO IMPORTAO ALTERAO SITUAO FUNCIONAL */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
              FROM RHREGOCORRENCIAS
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHREGOCORRENCIAS.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHREGOCORRENCIAS.UNIDADE
        ) TOTAL_ALTESITUFUNC;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_SITUACAO_FUNCIONAL;
    
        /* ----------------------------- */
    
        FOR C_RHREGOCORRENCIAS IN
          (SELECT RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, DATAINICIOOCORRENCIA, DATATERMINOOCORRENCIA, DATAHORAALTERACAO, 
                 DECODE(OCORRENCIA,
                        '004', '5',
                        '005', '100007',
                        '006', '100005',
                        '007', '100006',
                        '010', '4',
                        '011', '100008',
                        '012', '100007',
                        '013', '100004',
                        '100007') OCORRENCIA
            FROM RHREGOCORRENCIAS
            JOIN RHCONTRATOS
              ON RHCONTRATOS.CONTRATO = RHREGOCORRENCIAS.CONTRATO
             AND RHCONTRATOS.UNIDADE  = RHREGOCORRENCIAS.UNIDADE)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_SITU_FUNCIONAL (NRORG, DTINCLUSAO, NR_VINCULO, SIT_FUNCIONAL, DATA_INICIO, DATA_FIM)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHREGOCORRENCIAS.EMPRESA || C_RHREGOCORRENCIAS.PESSOA,
              C_RHREGOCORRENCIAS.OCORRENCIA,
              C_RHREGOCORRENCIAS.DATAINICIOOCORRENCIA,
              C_RHREGOCORRENCIAS.DATATERMINOOCORRENCIA
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_SITUACAO_FUNCIONAL;
    
    /* FIM IMPORTAO ALTERAO SITUAO FUNCIONAL */
    
    /* INICIO IMPORTAO FRIAS */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
               FROM RHFERIASCEDIDAS
               JOIN RHCONTRATOS
                 ON RHCONTRATOS.CONTRATO = RHFERIASCEDIDAS.CONTRATO
                AND RHCONTRATOS.UNIDADE  = RHFERIASCEDIDAS.UNIDADE
        ) TOTAL_FERIAS;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_FERIAS;
    
        /* ----------------------------- */
    
        FOR C_RHFERIASCEDIDAS IN
          (SELECT RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, INICIOPERAQUISITIVO, TERMINOPERAQUISITIVO, INICIOGOZOFERIAS, TERMINOGOZOFERIAS, DIASFERIASRECIBO, DIASABONORECIBO
             FROM RHFERIASCEDIDAS
             JOIN RHCONTRATOS
               ON RHCONTRATOS.CONTRATO = RHFERIASCEDIDAS.CONTRATO
              AND RHCONTRATOS.UNIDADE  = RHFERIASCEDIDAS.UNIDADE)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_FERIAS (NRORG, DTINCLUSAO, NR_VINCULO, INICIO_AQUISICAO, FIM_AQUISICAO, MES_AFASTAMENTO, STATUS_FERIAS, DIAS_AFASTAMENTO, INICIO_GOZO, FIM_GOZO, DIAS_ABONO, DT_RETORNO_FERIAS)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHFERIASCEDIDAS.EMPRESA || C_RHFERIASCEDIDAS.PESSOA,
              C_RHFERIASCEDIDAS.INICIOPERAQUISITIVO,
              C_RHFERIASCEDIDAS.TERMINOPERAQUISITIVO,
              NULL,
              NULL,
              NULL,
              C_RHFERIASCEDIDAS.INICIOGOZOFERIAS,
              C_RHFERIASCEDIDAS.TERMINOGOZOFERIAS,
              C_RHFERIASCEDIDAS.DIASABONORECIBO,
              NULL
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_FERIAS;
    
    /* FIM IMPORTAO FRIAS */
    
    /* INICIO IMPORTAO EVENTOS */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
              FROM RHVDB
        ) TOTAL_EVENTOS;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_EVENTO;
    
        /* ----------------------------- */
    
        FOR C_RHVDB IN
          (SELECT VDB, DESCRICAO30, DESCRICAO15, 
                 DECODE(TIPOVDB, 'V', 'PROVENTO', 'D', 'DESCONTO', 'B', 'TOTAL') TIPOVDB,
                 CASE
                    WHEN VDB = '1' THEN '10' /* Salrio */
                    WHEN VDB = '20' THEN '47' /* Adicional Noturno */
                    WHEN VDB = '21' THEN '50' /* Adicional Insalubridade */
                    WHEN VDB = '22' THEN '60' /* Adicional Periculosidade */
                    WHEN VDB = '25' THEN '70' /* Horas Extras 50 */
                    WHEN VDB = '87' THEN '73' /* Horas Extras 65 */
                    WHEN VDB = '27' THEN '80' /* Horas Extras 75 */
                    WHEN VDB = '26' THEN '90' /* Horas Extras 100 */
                    WHEN VDB = '52' THEN '110' /* 13 Salrio */
                    WHEN VDB = '28' THEN '140' /* Comisses */
                    WHEN VDB = '41' THEN '190' /* Aviso Prvio Indenizado */
                    WHEN VDB = '42' THEN '200' /* Aviso Prvio Inden. Adicional */
                    WHEN VDB = '61' THEN '210' /* Frias */
                    WHEN VDB = '85' THEN '211' /* Frias em Dobro */
                    WHEN VDB = '10' THEN '290' /* Diferena de Salrio */
                    WHEN VDB = '36' THEN '300' /* Salrio Famlia */
                    WHEN VDB = '431' THEN '330' /* Lic. Maternidade (p/encargos */
                    WHEN VDB = '4' THEN '330' /* Salrio Maternidade */
                    WHEN VDB = '5' THEN '336' /* Licena Paternidade */
                    WHEN VDB = '12' THEN '440' /* Pr-Labore */
                    WHEN VDB = '33' THEN '470' /* Adiantamento Salarial */
                    WHEN VDB = '110' THEN '480' /* Vale-Transporte */
                    WHEN VDB = '202' THEN '490' /* Falta Justificada */
                    WHEN VDB = '81' THEN '520' /* Diferena de Frias */
                    WHEN VDB = '199' THEN '760' /* Adto. p/Insuficincia de Saldo */
                    WHEN VDB = '43' THEN '800' /* Indenizao Art. 479 da CLT */
                    WHEN VDB = '14' THEN '810' /* Atestado */
                    WHEN VDB = '15' THEN '810' /* Atestado Acomp. Filho */
                    WHEN VDB = '19' THEN '840' /* Trinio */
                    WHEN VDB = '23' THEN '850' /* Quinqunio */
                    WHEN VDB = '201' THEN '1040' /* Faltas no Justificadas */
                    WHEN VDB = '212' THEN '1060' /* Contribuio Sindical */
                    WHEN VDB = '211' THEN '1060' /* Mensalidade Sindicato */
                    WHEN VDB = '214' THEN '1065' /* Contribuio Assistencial */
                    WHEN VDB = '213' THEN '1075' /* Contribuio Confederativa */
                    WHEN VDB = '221' THEN '1080' /* Vale-Transporte */
                    WHEN VDB = '381' THEN '1130' /* INSS sobre a Folha */
                    WHEN VDB = '382' THEN '1140' /* INSS sobre as Frias */
                    WHEN VDB = '384' THEN '1200' /* INSS s/o Pr-Labore/Autnomo */
                    WHEN VDB = '224' THEN '1250' /* Assistncia Mdico/Hosp Depend */
                    WHEN VDB = '218' THEN '1250' /* Assistncia Mdico/Hospitalar */
                    WHEN VDB = '235' THEN '1255' /* Assistncia Odonto Dependente */
                    WHEN VDB = '234' THEN '1255' /* Assistncia Odonto Titular */
                    WHEN VDB = '391' THEN '1330' /* I.R.F. sobre a Folha */
                    WHEN VDB = '392' THEN '1340' /* I.R.F. sobre as Frias */
                    WHEN VDB = '393' THEN '1350' /* I.R.F. sobre o 13 Salrio */
                    WHEN VDB = '205' THEN '1700' /* Indenizao Artigo 480 CLT */
                    WHEN VDB = '241' THEN '1710' /* Desconto Cesta Bsica */
                    WHEN VDB = '475' THEN '2040' /* FGTS sobre as Frias */
                    WHEN VDB = '485' THEN '2130' /* Contrib. Social s/FGTS-0,5 */
                    WHEN VDB = '500' THEN '3030' /* Lquido da Folha */
                    WHEN VDB = '499' THEN '3050' /* Lquido das Rescises */
                    WHEN VDB = '471' THEN '3060' /* Base FGTS sobre a Folha */
                    WHEN VDB = '472' THEN '3090' /* Base FGTS sobre as Frias */
                    WHEN VDB = '34' THEN '100016' /* Ajuda de Custo (< 50 */
                    WHEN VDB = '219' THEN '100016' /* Alimentao */
                END NRPEBBIAN    
            FROM RHVDB)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_EVENTO (NRORG, DTINCLUSAO, DATA_INICIO, TIPO_EVENTO, MES_COMPETENCIA, DESCRICAO, NR_EVENTO_PEBBIAN, NR_EVENTO_CLIENTE)
            VALUES (
              P_NRORG,
              SYSDATE,
              V_DTMESCOMPETENCIA,
              C_RHVDB.TIPOVDB,
              V_DTMESCOMPETENCIA,
              C_RHVDB.DESCRICAO30,
              C_RHVDB.NRPEBBIAN,
              C_RHVDB.VDB
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_EVENTO;
    
    /* FIM IMPORTAO EVENTOS */
    
    /* INICIO IMPORTAO MOVIMENTAES ESTRUTURAS */
    
        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
                FROM RHALTERACOESCONTRATO
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
               WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSIN'
             UNION ALL
             SELECT COUNT(1) TOTAL
                FROM RHALTERACOESCONTRATO
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
               WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSET'
        ) TOTAL_MOVIMENTACAO;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_MOV_ESTRUTURAS;
    
        /* ----------------------------- */
    
        FOR C_RHALTERACOESSINDICATO IN
          (SELECT CONTRATO, EMPRESA, PESSOA, DATAADMISSAO AS DATAHORAALTERACAO, VARIAVEL, NULL AS CODIGOANTERIOR, CODIGOANTERIOR AS CODIGOATUAL, NULL AS CONTEUDOANTERIOR, CONTEUDOANTERIOR AS CONTEUDOATUAL, MOTIVOTRANSFERENCIA
              FROM (SELECT ROW_NUMBER() OVER(PARTITION BY RHALTERACOESCONTRATO.CONTRATO ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) AS SEQUENCIAL, 
                           RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHCONTRATOS.DATAADMISSAO, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL,
                           V_MOTIVO_TRANS_ADM AS MOTIVOTRANSFERENCIA
                      FROM RHALTERACOESCONTRATO
                      JOIN RHCONTRATOS
                        ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                       AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
                     WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSIN' 
                     ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) ALTERACOES
             WHERE SEQUENCIAL = 1
             
            UNION ALL
            
            SELECT RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL,
                   V_MOTIVO_TRANS_ENT AS MOTIVOTRANSFERENCIA
              FROM RHALTERACOESCONTRATO
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
             WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSIN')
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_MOV_ESTRUTURAS (NRORG, DTINCLUSAO, NR_VINCULO, NR_TIPO_TRANSFERENCIA, NR_MOTIVO_TRANSFERENCIA, NR_ESTRUTURA, OBERVACAO, DT_FIM_MOVIMENTACAO, DT_INICIO_MOVIMENTACAO, NR_TIPO_ESTRUTURA, DT_MOV_RETROATIVA, MOTIVO_DA_TRANSFERENCIA)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHALTERACOESSINDICATO.EMPRESA || C_RHALTERACOESSINDICATO.PESSOA,
              V_MOV_LEGAL,
              C_RHALTERACOESSINDICATO.MOTIVOTRANSFERENCIA,
              C_RHALTERACOESSINDICATO.CODIGOATUAL || V_SINDICATO,
              NULL,
              NULL,
              TRUNC(C_RHALTERACOESSINDICATO.DATAHORAALTERACAO),
              V_SINDICATO,
              NULL,
              NULL
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
        
        /* ----------------------------------------------------------------------------------------- */
        
        FOR C_RHALTERACOESSETOR IN
          (SELECT CONTRATO, EMPRESA, PESSOA, DATAADMISSAO AS DATAHORAALTERACAO, VARIAVEL, NULL AS CODIGOANTERIOR, CODIGOANTERIOR AS CODIGOATUAL, NULL AS CONTEUDOANTERIOR, CONTEUDOANTERIOR AS CONTEUDOATUAL, MOTIVOTRANSFERENCIA
              FROM (SELECT ROW_NUMBER() OVER(PARTITION BY RHALTERACOESCONTRATO.CONTRATO ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) AS SEQUENCIAL, 
                           RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, RHCONTRATOS.DATAADMISSAO, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL,
                           V_MOTIVO_TRANS_ADM AS MOTIVOTRANSFERENCIA
                      FROM RHALTERACOESCONTRATO
                      JOIN RHCONTRATOS
                        ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
                       AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
                     WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSET' 
                     ORDER BY RHALTERACOESCONTRATO.CONTRATO, DATAHORAALTERACAO) ALTERACOES
             WHERE SEQUENCIAL = 1
             
            UNION ALL
            
            SELECT RHCONTRATOS.CONTRATO, RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, DATAHORAALTERACAO, VARIAVEL, CODIGOANTERIOR, CODIGOATUAL, CONTEUDOANTERIOR, CONTEUDOATUAL,
                   V_MOTIVO_TRANS_GER AS MOTIVOTRANSFERENCIA
              FROM RHALTERACOESCONTRATO
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHALTERACOESCONTRATO.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHALTERACOESCONTRATO.UNIDADE
             WHERE RHALTERACOESCONTRATO.VARIAVEL = 'CSET')
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_MOV_ESTRUTURAS (NRORG, DTINCLUSAO, NR_VINCULO, NR_TIPO_TRANSFERENCIA, NR_MOTIVO_TRANSFERENCIA, NR_ESTRUTURA, OBERVACAO, DT_FIM_MOVIMENTACAO, DT_INICIO_MOVIMENTACAO, NR_TIPO_ESTRUTURA, DT_MOV_RETROATIVA, MOTIVO_DA_TRANSFERENCIA)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHALTERACOESSETOR.EMPRESA || C_RHALTERACOESSETOR.PESSOA,
              V_MOV_GEREN,
              C_RHALTERACOESSETOR.MOTIVOTRANSFERENCIA,
              C_RHALTERACOESSETOR.CODIGOATUAL || V_SETOR,
              NULL,
              NULL,
              TRUNC(C_RHALTERACOESSETOR.DATAHORAALTERACAO),
              V_SETOR,
              NULL,
              NULL
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_MOV_ESTRUTURAS;
    
    /* FIM IMPORTAO MOVIMENTAES ESTRUTURAS */
    
    /* INICIO IMPORTAO MOVIMENTAES FINANCEIRAS */

        /* RETORNA TOTAL DE REGISTROS PARA O AGRUPADOR */
        SELECT SUM(TOTAL) 
          INTO V_TOTALREGISTROS
          FROM (
             SELECT COUNT(1) TOTAL
                FROM RHVDBFOLHA
                JOIN RHCONTRATOS
                  ON RHCONTRATOS.CONTRATO = RHVDBFOLHA.CONTRATO
                 AND RHCONTRATOS.UNIDADE  = RHVDBFOLHA.UNIDADE
        ) TOTAL_MOVFINANCEIRA;
        
        /* ATUALIZA LOG DA IMPORTAO POR AGRUPADOR */      
        UPDATE MIG_LOG_IMPORTACAO SET NRTOTALREGISTROS = V_TOTALREGISTROS, CDSTATUS = V_STATUS_ANDAMENTO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_MOV_FINANCEIROS;
    
        /* ----------------------------- */
            
        FOR C_RHVDBFOLHA IN
          (SELECT RHCONTRATOS.EMPRESA, RHCONTRATOS.PESSOA, TRUNC(DATAFOLHA, 'MM') DATAFOLHA, VDB, HORASQUANTIDADE, VALOR,
                   DECODE(CODIGOFOLHA,
                          '11', '1',
                          '21', '1',
                          '22', '1',
                          '31', '1',
                          '32', '1',
                          '33', '1',
                          '41', '1',
                          '51', '4',
                          '52', '4',
                          '61', '1',
                          '71', '1',
                          '81', '2',
                          '91', '1',
                          '92', '1') CODIGOFOLHA
              FROM RHVDBFOLHA
              JOIN RHCONTRATOS
                ON RHCONTRATOS.CONTRATO = RHVDBFOLHA.CONTRATO
               AND RHCONTRATOS.UNIDADE  = RHVDBFOLHA.UNIDADE)
              
        LOOP
        
          INSERT INTO MIG_TEMPLATE_MOV_FINANCEIROS (NRORG, DTINCLUSAO, TP_MOVIMENTO, NR_VINCULO, NR_EVENTO, VALOR, DESCRICAO_DO_CALCULO, DATA_DE_OCORRENCIA, VALOR_DE_REFERENCIA)
            VALUES (
              P_NRORG,
              SYSDATE,
              C_RHVDBFOLHA.CODIGOFOLHA,
              C_RHVDBFOLHA.EMPRESA || C_RHVDBFOLHA.PESSOA,
              C_RHVDBFOLHA.VDB,
              C_RHVDBFOLHA.VALOR,
              NULL,
              C_RHVDBFOLHA.DATAFOLHA,
              C_RHVDBFOLHA.HORASQUANTIDADE
            );
            
            IF (V_COUNT = V_COMMIT_LIMIT) THEN
              COMMIT;
              V_COUNT := 0;
            ELSE
              V_COUNT := V_COUNT + 1;
            END IF;
          
        END LOOP;
    
        /* ATUALIZA LOG DA IMPORTAO ANTERIOR PARA CONCLUIDO */      
        UPDATE MIG_LOG_IMPORTACAO SET CDSTATUS = V_STATUS_CONCLUIDO WHERE NRORG = P_NRORG AND DSAGRUPADOR = V_AGRUP_MOV_FINANCEIROS;
    
    /* FIM IMPORTAO MOVIMENTAES FINANCEIRAS */
    
  ELSE
    RAISE_APPLICATION_ERROR(-20501, 'Parmetros no informados corretamente.', TRUE);
  END IF;

END;